# recursion

# programming technique consists of 2 parts:
# 1. base case e.g. 1! = 1
# 2. recursive (inductive case) (n+1)! = (n+1)*n!


# 2 factorial implementations

# # iterative
# def factI(n):
# # assumes n is an integer > 0
# # returns n!
#   result = 1
#   while n > 1:
#     result = result*n
#     n -= 1
#   return result
#
# print('(iterative) 5! = %d' %factI(5) )


# #recursive
# def factR(n):
# # assumes n is an integer > 0
# # returns n!
#   if n == 1: #base case part
#     return n
#   else:
#     return n*factR(n-1) #inductive part
#
# print('(recursive) 5! = %d' %factR(5) )
# # how does a recursive call correspond to a stack frame?
#
# # #max recursion depth
# N = 1000
# print('(recursive) %d! = %d' %(N,factR(N)))


#
# # fibonacci sequence via recursion
# def fib(n):
# #assumes n is an integer >= 0
#   if n == 0 or n== 1: #base case
#     return 1
#   else:
#     return fib(n-1) + fib(n-2) #inductive step
#
# def testFib(n):
#   for i in range(n+1):
#     print('fib of', i, '=', fib(i))
#
# testFib(12)


import sys


# recursive implementation of palindromes
def isPalindrome(s):
  """assumes s is a string
  returns True if letters in s form a palindrome; False
  otherwise. Non-letters and caps are ignored"""

  def toChar(s):
    s = s.lower()
    letters = ''
    for c in s:
      if c in 'abcdefghijklmnopqrstuvwxyz':
        letters = letters + c
    return letters


  def isPal(s):
    if len(s) <= 1:
      return True
    else:
      answer = s[0] == s[-1] and isPal(s[1:-1])
      print('answer = ', answer)
      return answer

  return isPal(toChar(s))

isPalindrome('no X in Nixon!')

isPalindrome('Never odd or even')

isPalindrome('A man, a plan, a canal: Panama')

isPalindrome('Mr. Owl Ate My Metal Worm')

isPalindrome('Eva, Can I Stab Bats In A Cave?')




sys.exit()

'''
string formatting examples
COSC 120
Fall 2017, Dr. Fred Park
'''


print('hello world!')

print("hello world!")

print('fear the poet!!')

#old style string formatting, C-style string
print('My name is %s, I teach at %s' %('Dr. Park','Whittier College'))

# new style: invoke the format method from the string class (string object)
# object: user defined data type or simply: things python code manipulates
# everything in python is an object

#multiple output
print('My name is {} and I am a Prof. at {}, I teach {}'.format('Dr. Park','Whittier College','COSC 190'))

#multiple output with ordering
print('My name is {0} and I am a Prof. at {1}, I teach {2}'.format('Dr. Park','Whittier College','COSC 190'))

#multiple output with ordering changed
print('My name is {2} and I am a Prof. at {1}, I teach {0}'.format('Dr. Park','Whittier College','COSC 190'))

#multiple output with key instead of index
print('My name is {prof} and I am a Prof. at {school}, I teach {course}'.format(prof='Dr. Park', school='Whittier College', course='COSC 190'))

#multiple output, note order of keys
print('My name is {prof} and I am a Prof. at {school}, I teach {course}'.format(school='Whittier College', course='COSC 190', prof='Dr. Park'))


#{field_name:conversion}
#field_name: index or key to field
#conversion: conversion code

nm = input('please enter your name: ');
print('hello {:s}'.format)

nm = input('please enter your name: ');
mys = 'hello {:s}, today is {:s} which is day {:d} of the week if we start counting from Monday!'
print(mys.format('Fred','Friday',5))

import math as mt
pi = mt.pi
print('PI = %1.48f' %pi) # C-style string
print('PI = {:1.48f}'.format(pi)) #new style. invoke string method format


nd = 5
print('hello {:s}, 3 divided by 5 is = {:2.5f} \nnote we\'re using {:d} decimal places'.format('fred', 5/3, nd))

print('{:<30}'.format('left aligned'))

print('{:>30}'.format('right aligned'))

print('{:^30}'.format('centered'))

print('{:*^50}'.format('centered with space filler'))

print('{:*^80}'.format('center'))

print('{:<30} {:>30}'.format('left aligned','right aligned'))



for i in range(3,13):
    print(i, i*i, i*i*i)


for i in range(3,13):
    print("{0:5d} {1:7d} {2:6d}".format(i, i*i, i*i*i))


# 3 columns of numbers left justified with at least 2 spaces between them
for i in range(3,13):
    print("{0:<3d} {1:<4d} {2:<6d}".format(i, i*i, i*i*i))
